
# solar panel basic stuff

execute as @e[type=item,nbt={Item:{id:"minecraft:copper_block",count:1}}] at @s if block ~ ~ ~ daylight_detector[inverted=false] align xyz run function nbauto:solarpannel/create
execute as @e[type=block_display,tag=solarpanel] run function nbauto:solarpannel/checkduplicate
execute as @e[type=block_display,tag=solarpanel] at @s unless block ~ ~ ~ daylight_detector[inverted=false] run function nbauto:solarpannel/destroy

# solar panel unique behavior

execute as @e[type=block_display,tag=solarpanel,predicate=nbauto:solarpanelcheckpower] at @s run function nbauto:solarpannel/producepower

# chunk loader basic stuff

execute if score _chunkloader_enabled nbauto_settings matches 0 as @e[type=item,nbt={Item:{id:"minecraft:compass",count:1}}] at @s if block ~ ~-1 ~ redstone_block align xyz run function nbauto:chunkloader/create
execute if score _chunkloader_enabled nbauto_settings matches 0..1 as @e[type=item,nbt={Item:{id:"minecraft:nether_star",count:1}}] at @s if block ~ ~-1 ~ redstone_block align xyz run function nbauto:chunkloader/create
execute as @e[type=block_display,tag=chunkloader] run function nbauto:chunkloader/checkduplicate
execute as @e[type=block_display,tag=chunkloader] at @s unless block ~ ~ ~ redstone_block run function nbauto:chunkloader/destroy

# chunk loader unique behavior
execute as @e[type=block_display,tag=chunkloader,scores={nbenergy=..0}] at @s run forceload remove ~ ~ ~ ~
execute as @e[type=block_display,tag=chunkloader,scores={nbenergy=1..}] at @s run forceload add ~ ~ ~ ~
execute as @e[type=block_display,tag=chunkloader,scores={nbenergy=1..}] at @s run scoreboard players remove @s nbenergy 1
execute as @e[type=block_display,tag=chunkloader] at @s if entity @p[distance=..2] run function nbauto:chunkloader/debug

# gigabulb basic stuff

execute as @e[type=item,nbt={Item:{id:"minecraft:glowstone",count:1}}] at @s if block ~ ~-1 ~ #nbauto:gigabulb align xyz run function nbauto:gigabulb/place
execute as @e[type=block_display,tag=gigabulb] run function nbauto:gigabulb/checkduplicate
execute as @e[type=block_display,tag=gigabulb] at @s unless block ~ ~ ~ #nbauto:gigabulb run function nbauto:gigabulb/remove

# gigabulb unique behavior

execute as @e[type=block_display,tag=gigabulb] at @s run function nbauto:gigabulb/20t
execute if score #ServerUpdateGigaBulbs nbgigabulbstate matches 1 as @e[type=block_display,tag=gigabulb] at @s run function nbauto:gigabulb/off
execute if score #ServerUpdateGigaBulbs nbgigabulbstate matches 1 as @e[type=block_display,tag=gigabulb] at @s run function nbauto:gigabulb/setstateon
execute if score #ServerUpdateGigaBulbs nbgigabulbstate matches 1 as @e[type=block_display,tag=gigabulb] at @s run scoreboard players set #ServerUpdateGigaBulbs nbgigabulbstate 0

# catalystic converter basic stuff

execute as @e[type=item,nbt={Item:{id:"minecraft:copper_block",count:1}}] at @s if block ~ ~-1 ~ sculk_catalyst align xyz run function nbauto:catalystic_conerter/create
execute as @e[type=block_display,tag=nbauto_catalystic_converter] at @s run function nbauto:catalystic_conerter/checkduplicate
execute as @e[type=block_display,tag=nbauto_catalystic_converter] at @s unless block ~ ~ ~ sculk_catalyst run function nbauto:catalystic_conerter/destroy

# energy extras

kill @e[type=text_display,tag=energyvisualizer]
execute as @e[type=#nbauto:energy,tag=nbenergy] at @s run function nbauto:energy/20t
execute as @e[type=block_display,tag=nbwirecorner] at @s run function nbauto:energy/wirecorner/20t
execute as @e[type=block_display,tag=chain_split,predicate=nbauto:not_chain,limit=64] run kill @s
# next function

schedule function nbauto:20tick-2 5t